function Classification_param(n_solver, rep, fold, i, j)
% Builds DFs. 

% Load the PreClassification results.
PC = load('PreClassification.mat');
P = PC.P;
X_TRAIN = PC.X_TRAIN;
X_TRAIN_IDs = PC.X_TRAIN_IDs;
PORTFOLIO = PC.PORTFOLIO;

% nosolver (backup solver is chosen) is placed in 2nd position.
ASP = [3 13 8 12 4 11 9 7 5 10 1 6 2];
% Returns the ID of the solver which resolves more instances.
function best = bestASP(i, j)
    if ASP(i) < ASP(j)
        best = i;
    else
        best = j;
    end
end

% Builds DF(i, j).
NUM_TREES = 99
NUM_FEAT = 130;
NVAR = ceil(log2(NUM_FEAT) + 1);
sprintf('No. solvers: %d', n_solver)
sprintf('Repetition: %d', rep)
sprintf('Fold: %d', fold)
x = X_TRAIN{rep}{fold};
sprintf('i-th solver ID: %d', i)
sprintf('j-th solver ID: %d', j)
idx = X_TRAIN_IDs{rep}{fold};
y = zeros(size(idx));
Pi = P(idx, i);
Pj = P(idx, j);
y(Pi < Pj) = i;
y(Pj < Pi) = j;
y(Pi == Pj) = bestASP(i, j);
w = abs(Pi - Pj);
if length(x) == length(y) + 1
    x = x(1:length(y), :);
end
sprintf('Bagging...')
DF = TreeBagger(NUM_TREES, x, y, 'Method', 'classification', 'W', w, 'NVarToSample', NVAR);
disp(DF)
save(strcat(num2str(n_solver), '_solvers/class_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold), '_i', num2str(i), '_j', num2str(j)), 'DF');

end
