function Predictions_param(n_solver, rep, fold)
% Build predictions.

PC = load('PreClassification.mat');
PORTFOLIO = PC.PORTFOLIO;

PP = load('PrePredictions.mat');
X_TEST = PP.X_TEST;
SOLVERs = PP.SOLVERs;
NUM_SOLV = 12;

% nosolver (backup solver is chosen) is placed in 2nd position.
ASP = [3 13 8 12 4 11 9 7 5 10 1 6 2];
% Returns the ID of the solver which resolves more instances.
function best = bestASP(i, j)
    if ASP(i) < ASP(j)
        best = i;
    else
        best = j;
    end
end

%Build predictions.
pf = PORTFOLIO{n_solver}';
sprintf('No. solvers: %d', n_solver)
sprintf('Repetition: %d', rep)
sprintf('Fold: %d', fold)
x = X_TEST{rep}{fold};
n = length(x);
if sum(x(n, :)) == 0
  n = n - 1;
  x = x(1:n, :);
end
m = n_solver + 1;
V = zeros(n, m * (m - 1) / 2);
k = 0;
for i = pf
    for j = pf
	if i < j
	    sprintf('i-th solver ID: %d', i)
	    sprintf('j-th solver ID: %d', j)
	    CL = load(strcat(num2str(n_solver), '_solvers/class_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold), '_i', num2str(i), '_j', num2str(j)));
	    DF = CL.DF;          
	    y_pred = predict(DF, x);
	    k = k + 1;
	    V(:, k) = str2double(y_pred);
	end
    end
end
Y = zeros(n, 1);
S = cell(n, 1);
for k = 1:n              
    pf = PORTFOLIO{n_solver}';
    votes = zeros(1, NUM_SOLV + 1);         
    for h = pf
	votes(h) = sum(V(k, :) == h);
    end
    tie = find(votes == max(votes));
    Y(k) = tie(1);
    for h = 2:length(tie)
	% FIXME: This is not the paper's way.
	Y(k) = bestASP(Y(k), tie(h));    
    end
    S{k} = SOLVERs{Y(k)};
end
fid = fopen(strcat(num2str(n_solver), '_solvers/test_', num2str(n_solver), 'solvers_rep', num2str(rep), '_fold', num2str(fold)), 'w');
fprintf(fid, '%s\n', S{:});

end
