'''
Computes the features needed by SATzilla approach.
'''

import sys
import csv
import json

FEAT_VECTOR = '/public/xcsp_instances/new/features/cop/feat_vector_rn'
with open(FEAT_VECTOR, 'r') as infile:
  feat_vector = json.load(infile)
IN_PATH = '/public/xcsp_instances/new/dataset/cop/train_test/'
OUT_PATH = '/public/xcsp_instances/new/scripts/classifiers/cop/SATzilla/features/'

def main(args):

  for rep in range(1, 6):
    for fold in range(1, 6):
      suffix = 'rep' + str(rep) + '_fold' + str(fold)
      train = csv.reader(open(IN_PATH + 'train_' + suffix))
      feat_writer = csv.writer(
        open(OUT_PATH + 'train_'+ suffix + '.features', 'wb'),  delimiter = ' '
      )
      for inst in train:
        row = [inst[0]]
        row.extend(feat_vector[inst[0]])
        feat_writer.writerow(row)

      test = csv.reader(open(IN_PATH + 'test_' + suffix))
      feat_writer = csv.writer(
        open(OUT_PATH + 'test_'+ suffix + '.features', 'wb'),  delimiter = ' '
      )
      for inst in test:
        row = [inst[0]]
        row.extend(feat_vector[inst[0]])
        feat_writer.writerow(row)

if __name__ == '__main__':
  main(sys.argv[1:])

