'''
Computes 'anti-scores' matrix.
'''

import sys
import json

INFOS = '/public/xcsp_instances/new/scripts/solvers/cop/infos'
NUM_INSTANCES = 2670
NUM_SOLVERS = 12

def main(args):
  P = {}
  with open(INFOS, 'r') as infile:
    infos = json.load(infile)
  P[0, 0] = 'inst'
  i = 0
  solvers = []
  for (inst, item) in infos.items():
    j = 1
    if i == 0:
      solvers = sorted(item.keys())
      j = 1
      for solver in solvers:
        P[0, j] = solver
        j += 1
      P[0, j] = 'nosolver'
      j = 1
      i = 1
    for solver in solvers:
      P[i, j] = 1 - item[solver]['score']
      j += 1
    P[i, j] = 1
    P[i, 0] = inst
    i += 1
  
  for i in range(0, NUM_INSTANCES + 1):
    row = ''
    for j in range(0, NUM_SOLVERS + 1):            
      row += str(P[i, j]) + ' '
    print row + str(P[i, NUM_SOLVERS + 1])
    
if __name__ == '__main__':
    main(sys.argv[1:])
