'''
Extracts infos for SUNNY.
'''

import csv
import json
import sys
num_solvers = 12
TIMEOUT = 900.0

def main(args):
  k = '16'
  file_path = '/public/xcsp_instances/new/predictions/cop/3S'
  res_path = '/public/xcsp_instances/new/scripts/classifiers/cop/mznc/results'
  with open(res_path, 'r') as infile:
    results = json.load(infile)
    infile.close()
  for n_solver in range(2, num_solvers + 1):
    data = csv.reader(
      open(file_path + '/results_3S_' + str(n_solver) + 'solvers', 'rb'), 
      delimiter='|', 
      skipinitialspace = True
    )
    for line in data:
      if line:
	rep = line[1]
        inst = line[8]
        score = float(line[9])
        time = float(line[10])
        if score == 1:
	  opt = 1
	  otime = time
	else:
	  opt = 0
	  otime = TIMEOUT
	assert 0 <= score <= 1
	assert 0 <= otime <= TIMEOUT
	assert score == 1 or otime == TIMEOUT
        results[str(n_solver)][inst][rep]['3s'] = (score, opt, otime, None)
        
    data = csv.reader(
      open(file_path + '/0_1/results_3S_' + str(n_solver) + 'solvers', 'rb'), 
      delimiter='|', 
      skipinitialspace = True
    )
    for line in data:
      if line:
	n = line[0]
	rep = line[1]
        inst = line[8]
        score = float(line[9])
        results[str(n_solver)][inst][rep]['3s'] += (score,)
    
  with open(res_path, 'w') as outfile:
    json.dump(results, outfile)
if __name__ == '__main__':
    main(sys.argv[1:])
