'''
Fix inconsistent outcomes.
'''
import sys
import json
from math import isnan
info_file = '/public/xcsp_instances/new/scripts/solvers/cop/infos'
TIMEOUT = 900.0

def main(args):
  ranges = [(0.1, 0.9), (0.2, 0.8), (0, 1)]
  with open(info_file, 'r') as infile:
    infos = json.load(infile)
  for (inst, solvers) in infos.items():
    opt = filter(lambda s : solvers[s]['score'] == 1, solvers.keys())
    if not opt:
      continue
    not_opt = set(solvers.keys()) - set(opt)
    objs = [solvers[s]['val'] for s in opt if not isnan(solvers[s]['val'])]
    if objs and min(objs) != max(objs):
      print inst, objs, solvers
    
    obj = infos[inst][opt[0]]['val']
    for solver in not_opt:
      item = infos[inst][solver]
      if (item['obj'] == 'min' and item['val'] < obj) \
      or (item['obj'] == 'max' and item['val'] > obj):
        print inst, solver, item['obj'], item['val'], obj
        item['score'] = 0
        item['area'] = TIMEOUT
        for (a, b) in ranges:
	  solvers[solver]['score_' + str(a) + '_' + str(b)] = 0
	  solvers[solver]['area_' + str(a) + '_' + str(b)] = TIMEOUT
        item['otime'] = TIMEOUT
        item['vals'] = {}
        item['val']  = float('nan')
        item['info'] = 'unknown'
        for s in solvers.keys():
	  if item['obj'] == 'min': 
            infos[inst][s]['min_val'] = obj
          else:
            infos[inst][s]['max_val'] = obj     
  infile.close()
  with open(info_file, 'w') as outfile:
    json.dump(infos, outfile)    
if __name__ == '__main__':
    main(sys.argv[1:])
