'''
Fix inconsistent outcomes.
'''
import sys
import csv

infotimes_file = 'infotimevals_cop'
fixed_file  = 'fixed_cop.csv'
TIMEOUT = 900
NUM_SOLVERS = 12

def main(args):
  infotimes_reader = csv.reader(open(infotimes_file, 'rb'),  delimiter = '|')
  infotimes_writer = csv.writer(open('infotimevals_cop_NEW', 'wb'), delimiter = '|')
  fixed_reader = csv.reader(open(fixed_file, 'rb'),  delimiter = '|')
  
  fixed = {}
  header = fixed_reader.next()
  for row in fixed_reader:
    inst = row[0]
    for i in range(1, NUM_SOLVERS + 1):
      solv = header[i]
      fixed.setdefault(inst, {})[solv] = row[i]

  infotimes = {}
  fixed_insts = fixed.keys()
  for row in infotimes_reader:
    inst = row[0]
    infotimes = eval(row[1])
    if inst in fixed_insts:
      for item in eval(row[1]).items():
        solv = item[0]
        if fixed[inst][solv] != 'nan':
          new_tuple = (fixed[inst][solv], infotimes[solv][1], infotimes[solv][2], infotimes[solv][3])
          infotimes[solv] = new_tuple
    infotimes_writer.writerow([inst, infotimes])
   
if __name__ == '__main__':
    main(sys.argv[1:])
